#include "sprite.h"

//costruttore che si occupa di inizializzare tutti i dati necessari
sprite::sprite(vector <string> files,  int init_x, int init_y, int speed)
{
	//contatori
	int i,num_files=files.size();

	//puntatore temporaneo
	frame * temp_frame;
	
	//alloco tutti i frame necessari
	for(i=0;i<num_files;i++)
	{
		temp_frame= new frame (files[i],110);  		
		frames.push_back(temp_frame);
	}
	
	//inizializziamo le cordinate dello sprite	
	x=init_x;
	y=init_y;

	//settiamo la velocit dello sprite
	s_speed=speed;

	//il primo frame ha indice 0
	cur_frame=0;

	//il tempo iniziale  0 
	update_time=0;

	//inizialmente non ci muoviamo
	moving=false;
}

//function che si occupa di gestire il disegno e l'animazione dello sprite
void sprite::draw_sprite()
{
	//se  passato il tempo necessario passiamo al prossimo frame
	if(update_time+(frames[cur_frame]->get_pause())<SDL_GetTicks())
    	{
		cur_frame++;

		//se siamo all'ultimo frame torniamo a 0
		if(cur_frame==(frames.size())) 
			cur_frame=0;

		//aggiorniamo il tempo dell'ultima modifica 
	      	update_time = SDL_GetTicks();
	}

	//indichiamo le cordinate del tank
	SDL_Rect dest_t;
	dest_t.x = x; 
	dest_t.y = y;
	dest_t.w = frames[cur_frame]->get_w(); 
	dest_t.h = frames[cur_frame]->get_h(); 
	
	//disegnamo il tank su screen
	if(moving)
		SDL_BlitSurface(frames[cur_frame]->get_surface(), NULL, screen,&dest_t);
	else
	{
		SDL_BlitSurface(frames[0]->get_surface(), NULL, screen,&dest_t);
		cur_frame=0;
	}

	//consideriamo l'animazione finita	
	moving=false;

}

//function che ridisegna il background modificato dallo sprite
void sprite::draw_bg()
{
	//aggiorniamo il rettangolo che circonda il tank
	SDL_Rect rect_bg;
	rect_bg.x = x-s_speed; 
	rect_bg.y = y-s_speed;
	rect_bg.w = frames[cur_frame]->get_w()+(s_speed*2);
	rect_bg.h = frames[cur_frame]->get_h()+(s_speed*2);

	//copiamo la parte di bg necessaria su screen
	SDL_BlitSurface(bg, &rect_bg, screen, &rect_bg);
}

//function spostamento orizzontale
void sprite::mov_x(int mov) 
{ 
	//ci spostiamo in base ad s_speed
	x+=mov*s_speed; 
	//segnaliamo che ci stiamo muovendo
	moving=true;
}

//function spostamento verticale
void sprite::mov_y(int mov) 
{ 
	//ci spostiamo in base ad s_speed
	y+=mov*s_speed; 
	//segnaliamo che ci stiamo muovendo
	moving=true;
}

//distruttore
sprite::~sprite()
{
	//contatori
	int i,num_files=frames.size();
	
	//chiamiamo il distruttore dei vari frame allocati precendentemente
	for(i=0;i<num_files;i++)
	{
		frames[i]->~frame();
	}
}
